Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/icmp6.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/icmp6.h	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/icmp6.h	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -102,6 +102,4 @@
 #define _IP_ICMP6_H_
 
-#ifdef SUPPORT_INET6
-
 /*
  *  ICMPv6 ヘッダ
@@ -117,5 +115,5 @@
 		uint8_t		data8[4];
 		} data;
-	} __attribute__((packed, aligned(2)))T_ICMP6_HDR;
+	} __attribute__((packed, aligned(2))) T_ICMP6_HDR;
 
 #define icmp6_data32			data.data32
@@ -133,5 +131,5 @@
 #define GET_ICMP6_SDU(nbuf,ihoff)	((uint8_t*)((nbuf)->buf) + ihoff + ICMP6_HDR_SIZE)
 
-#define GET_IP6_ICMP6_HDR_SIZE(nbuf)	(GET_IP6_HDR_SIZE(GET_IP6_HDR(nbuf)) + ICMP6_HDR_SIZE)
+#define GET_IP6_ICMP6_HDR_SIZE(nbuf)	(GET_IP6_HDR_SIZE(nbuf) + ICMP6_HDR_SIZE)
 #define GET_IF_IP6_ICMP6_HDR_SIZE(nbuf)	(IF_HDR_SIZE + GET_IP6_ICMP6_HDR_SIZE(nbuf))
 
@@ -218,5 +216,5 @@
 	T_IN6_ADDR	target;
 	/* この後にオプションが続く */
-	} __attribute__((packed, aligned(2)))T_NEIGHBOR_SOLICIT_HDR;
+	} T_NEIGHBOR_SOLICIT_HDR;
 
 #define NEIGHBOR_SOLICIT_HDR_SIZE	(sizeof(T_NEIGHBOR_SOLICIT_HDR))
@@ -230,5 +228,5 @@
 
 #define GET_IP6_NEIGHBOR_SOLICIT_HDR_SIZE(nbuf)		\
-					(GET_IP6_HDR_SIZE(GET_IP6_HDR(nbuf)) + NEIGHBOR_SOLICIT_HDR_SIZE)
+					(GET_IP6_HDR_SIZE(nbuf) + NEIGHBOR_SOLICIT_HDR_SIZE)
 #define GET_IF_IP6_NEIGHBOR_SOLICIT_HDR_SIZE(nbuf)	\
 					(GET_IP6_NEIGHBOR_SOLICIT_HDR_SIZE(nbuf) + IF_HDR_SIZE)
@@ -242,5 +240,5 @@
 	T_IN6_ADDR	target;
 	/* この後にオプションが続く */
-	} __attribute__((packed, aligned(2)))T_NEIGHBOR_ADVERT_HDR;
+	} __attribute__((packed, aligned(2))) T_NEIGHBOR_ADVERT_HDR;
 
 /* ICMP6 ヘッダのデータ部の定義 */
@@ -261,5 +259,5 @@
 
 #define GET_IP6_NEIGHBOR_ADVERT_HDR_SIZE(nbuf)		\
-					(GET_IP6_HDR_SIZE(GET_IP6_HDR(nbuf)) + NEIGHBOR_ADVERT_HDR_SIZE)
+					(GET_IP6_HDR_SIZE(nbuf) + NEIGHBOR_ADVERT_HDR_SIZE)
 #define GET_IF_IP6_NEIGHBOR_ADVERT_HDR_SIZE(nbuf)	\
 					(GET_IP6_NEIGHBOR_ADVERT_HDR_SIZE(nbuf) + IF_HDR_SIZE)
@@ -285,4 +283,8 @@
 /*
  *  ルータ通知
+ *
+ *    RFC4291: IP Version 6 Addressing Architecture
+ *    RFC4941: Privacy Extensions for Stateless Address Autoconfiguration in IPv6
+ *    RFC6106: IPv6 Router Advertisement Options for DNS Configuration
  */
 
@@ -292,5 +294,5 @@
 	uint32_t	retransmit;		/* [ms] 近隣要請送信間隔	*/
 	/* この後にオプションが続く */
-	} __attribute__((packed, aligned(2)))T_ROUTER_ADVERT_HDR;
+	} __attribute__((packed, aligned(2))) T_ROUTER_ADVERT_HDR;
 
 /* ICMP6 ヘッダのデータ部の定義 */
@@ -311,5 +313,5 @@
 
 #define GET_IP6_ROUTER_ADVERT_HDR_SIZE(nbuf)	\
-					(GET_IP6_HDR_SIZE(GET_IP6_HDR(nbuf)) + ROUTER_ADVERT_HDR_SIZE)
+					(GET_IP6_HDR_SIZE(nbuf) + ROUTER_ADVERT_HDR_SIZE)
 #define GET_IF_IP6_ROUTER_ADVERT_HDR_SIZE(nbuf)	\
 					(GET_IP6_ROUTER_ADVERT_HDR_SIZE(nbuf) + IF_HDR_SIZE)
@@ -324,4 +326,15 @@
 
 /*
+ *  M: RA以外の方法で自動的にアドレスを設定することを許可する。
+ *  O: RA以外の方法で自動的にアドレス以外の情報を設定することをを許可する。
+ *
+ *   M   O
+ *  ON  ON	アドレスとそれ以外の情報をDHCPv6で設定する（statefull）
+ *  ON  OFF	アドレスはDHCPv6で設定するが、それ以外は手動で設定する。
+ *  OFF ON	アドレスは RA で設定するが、それ以外の情報をDHCPv6で設定する（stateless）
+ *  OFF OFF	DHCPv6 は使用しない。
+ */
+
+/*
  *  ルータ要請
  */
@@ -329,5 +342,5 @@
 typedef struct t_router_solicit_hdr {
 	T_ICMP6_HDR	hdr;
-	} __attribute__((packed, aligned(2)))T_ROUTER_SOLICIT_HDR;
+	} __attribute__((packed, aligned(2))) T_ROUTER_SOLICIT_HDR;
 
 /* ICMP6 ヘッダのデータ部の定義 */
@@ -347,5 +360,5 @@
 
 #define GET_IP6_ROUTER_SOLICIT_HDR_SIZE(nbuf)		\
-					(GET_IP6_HDR_SIZE(GET_IP6_HDR(nbuf)) + ROUTER_SOLICIT_HDR_SIZE)
+					(GET_IP6_HDR_SIZE(nbuf) + ROUTER_SOLICIT_HDR_SIZE)
 #define GET_IF_IP6_ROUTER_SOLICIT_HDR_SIZE(nbuf)	\
 					(GET_IP6_ROUTER_SOLICIT_HDR_SIZE(nbuf) + IF_HDR_SIZE)
@@ -360,5 +373,5 @@
 	T_ICMP6_HDR	hdr;
 	T_IN6_ADDR	target;
-	} __attribute__((packed, aligned(2)))T_NEIGHBOR_HDR;
+	} __attribute__((packed, aligned(2))) T_NEIGHBOR_HDR;
 
 /* 近隣探索オプションヘッダ */
@@ -367,5 +380,5 @@
 	uint8_t		type;			/* オプションタイプ			*/
 	uint8_t		len;			/* オプション長、単位は 8 バイト	*/
-	} __attribute__((packed, aligned(2)))T_ND_OPT_HDR;
+	} __attribute__((packed, aligned(2))) T_ND_OPT_HDR;
 
 #define ND_OPT_HDR_SIZE			(sizeof(T_ND_OPT_HDR))
@@ -393,5 +406,5 @@
 	uint32_t	reserved;
 	T_IN6_ADDR	prefix;		/* プレフィックス		*/
-	} __attribute__((packed, aligned(2)))T_ND_OPT_PREFIX_INFO;
+	} __attribute__((packed, aligned(2))) T_ND_OPT_PREFIX_INFO;
 
 #define ND_OPT_PI_FLAG_ONLINK	UINT_C(0x80)		/* オンリンクプレフィックス	*/
@@ -405,5 +418,5 @@
 	uint16_t	reserved;
 	uint32_t	mtu;		/* MTU				*/
-	} __attribute__((packed, aligned(2)))T_ND_OPT_MTU_HDR;
+	} __attribute__((packed, aligned(2))) T_ND_OPT_MTU_HDR;
 
 /*
@@ -416,5 +429,5 @@
 	T_IN6_ADDR	dst;		/* 向け直しの終点アドレス		*/
 	/* この後にオプションが続く */
-	} __attribute__((packed, aligned(2)))T_ND_REDIRECT_HDR;
+	} __attribute__((packed, aligned(2))) T_ND_REDIRECT_HDR;
 
 #define ND_REDIRECT_HDR_SIZE		(sizeof(T_ND_REDIRECT_HDR))
@@ -480,5 +493,3 @@
 #endif	/* of #ifdef ICMP_CFG_CALLBACK_ECHO_REPLY */
 
-#endif	/* of #ifdef SUPPORT_INET6 */
-
 #endif	/* of #ifndef _IP_ICMP6_H_ */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/icmp_var.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/icmp_var.h	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/icmp_var.h	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/if_ether.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/if_ether.c	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/if_ether.c	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -94,4 +94,5 @@
 #include <net/if_arp.h>
 #include <net/net.h>
+#include <net/net_endian.h>
 #include <net/net_buf.h>
 #include <net/net_var.h>
@@ -106,5 +107,5 @@
 #include <net/if_var.h>
 
-#if defined(SUPPORT_INET4) && defined(SUPPORT_ETHER)
+#if defined(_IP4_CFG) && defined(SUPPORT_ETHER)
 
 /*
@@ -118,9 +119,168 @@
  */
 
-static T_ARP_ENTRY *arp_lookup (T_IN4_ADDR addr, bool_t create);
 static void in_arpinput (T_IF_ADDR *ifaddr, T_NET_BUF *input);
 static void arp_timer (void *ignore);
 
 /*
+ *  in_arpinput -- TCP/IP 用 ARP の入力関数
+ */
+
+static void
+in_arpinput (T_IF_ADDR *ifaddr, T_NET_BUF *input)
+{
+	T_NET_BUF	*pending;
+	T_ETHER_HDR	*eth;
+	T_ARP_HDR	*arph;
+	T_ETHER_ARP_HDR	*et_arph;
+	T_ARP_ENTRY	*ent;
+	T_IFNET		*ifp = IF_GET_IFNET();
+	T_IN4_ADDR	saddr, taddr;
+
+	et_arph = GET_ETHER_ARP_HDR(input);
+
+	ntoahl(saddr, et_arph->sproto);		/* 送信元 IP アドレス	*/
+	ntoahl(taddr, et_arph->tproto);		/* 解決対象 IP アドレス	*/
+
+	/*
+	 *  以下の場合はエラー
+	 *    ・送信ホストの物理アドレスが自分
+	 *    ・送信ホストの物理アドレスがブロードキャスト
+	 */
+	if (memcmp(et_arph->shost, ifaddr->lladdr,        ETHER_ADDR_LEN) == 0 ||
+	    memcmp(et_arph->shost, ether_broad_cast_addr, ETHER_ADDR_LEN) == 0)
+		goto err_ret;
+
+	/*
+	 *  送信ホストの IP アドレスが自分の場合は、重複しているので
+	 *  相手にも知らせる。
+	 *  ただし、自分と相手のアドレスが未定義（IPV4_ADDRANY）の時は何もしない。
+	 */
+	if ((saddr == ifp->in4_ifaddr.addr) && (saddr != IPV4_ADDRANY)) {
+
+#ifdef ARP_CFG_CALLBACK_DUPLICATED
+
+		if (arp_callback_duplicated(et_arph->shost)) {
+			syslog(LOG_ERROR, "[ARP] IP address duplicated: %s",
+			                  ip2str(NULL, &ifp->in4_ifaddr.addr),
+			                  mac2str(NULL, et_arph->shost));
+			taddr = saddr;
+			goto reply;
+			}
+		else
+			goto buf_rel;
+
+#else	/* of #ifdef ARP_CFG_CALLBACK_DUPLICATED */
+
+		syslog(LOG_ERROR, "[ARP] IP address duplicated: %s",
+			          ip2str(NULL, &ifp->in4_ifaddr.addr),
+			          mac2str(NULL, et_arph->shost));
+		taddr = saddr;
+		goto reply;
+
+#endif	/* of #ifdef ARP_CFG_CALLBACK_DUPLICATED */
+
+		}
+
+	/*
+	 *  以下の場合は何もしない。
+	 *    ・解決対象 IP アドレスが自分ではない、注: 元の FreeBSD の
+	 *      実装では、ARP PROXY 等のため、自分以外の IP アドレスの
+	 *      解決も行っているが、本実装では、自分以外の IP
+	 *      アドレスの解決は行わない。
+	 */
+	if (taddr != ifp->in4_ifaddr.addr)
+		goto buf_rel;
+
+	/*
+	 *  送信元 IP アドレスが ARP キャッシュにあるか調べる。
+	 *  キャッシュになければ、新たにエントリを登録する。
+	 */
+	syscall(wai_sem(SEM_ARP_CACHE_LOCK));
+	ent = arp_lookup(saddr, true);
+
+	memcpy(ent->mac_addr, et_arph->shost, ETHER_ADDR_LEN);
+	ent->expire = ARP_CACHE_KEEP;
+
+	/*
+	 *  送信がペンデングされているフレームがあれば送信する。
+	 */
+	if (ent->hold) {
+
+		/* フレームの Ethernet ヘッダを設定する。*/
+		memcpy(GET_ETHER_HDR(ent->hold)->dhost, ent->mac_addr, ETHER_ADDR_LEN);
+
+		pending = ent->hold;
+		ent->hold = NULL;
+		syscall(sig_sem(SEM_ARP_CACHE_LOCK));
+
+		/* ペンディングされているフレームを送信する。*/
+		IF_RAW_OUTPUT(pending, TMO_FEVR);
+
+		}
+	else
+		syscall(sig_sem(SEM_ARP_CACHE_LOCK));
+
+reply:
+
+	arph = GET_ARP_HDR(input);
+
+	/* アドレス解決要求でなければ終了 */
+	if (ntohs(arph->opcode) != ARPOP_REQUEST)
+		goto buf_rel;
+
+	/* Ethernet ARP ヘッダを設定する。*/
+	memcpy(et_arph->thost, et_arph->shost, ETHER_ADDR_LEN);
+	memcpy(et_arph->shost, ifaddr->lladdr, ETHER_ADDR_LEN);
+	memcpy(et_arph->tproto, (uint8_t*)&et_arph->sproto, sizeof(T_IN_ADDR));
+	ahtonl(et_arph->sproto, taddr);
+
+	/* Ethernet ARP ヘッダを設定する。*/
+	arph->opcode = htons(ARPOP_REPLY);
+
+	/* Ethernet ヘッダを設定する。*/
+	eth = GET_ETHER_HDR(input);
+	memcpy(eth->dhost, eth->shost,     ETHER_ADDR_LEN);
+	memcpy(eth->shost, ifaddr->lladdr, ETHER_ADDR_LEN);
+
+	/* ARP 応答を送信する。*/
+	IF_RAW_OUTPUT(input, TMO_FEVR);
+	return;
+
+err_ret:
+	NET_COUNT_ARP(net_count_arp.in_err_packets, 1);
+buf_rel:
+	syscall(rel_net_buf(input));
+	}
+
+/*
+ *  arp_timer -- ARP キャッシュの更新
+ */
+
+static void
+arp_timer (void *ignore)
+{
+	int_t	ix;
+
+	syscall(wai_sem(SEM_ARP_CACHE_LOCK));
+
+	for (ix = NUM_ARP_ENTRY; ix -- > 0; ) {
+		if (arp_cache[ix].expire) {
+			arp_cache[ix].expire -= ARP_TIMER_TMO;
+			if (arp_cache[ix].expire == 0) {
+				/* 送信がペンデングされているフレームがあれば捨てる。*/
+				if (arp_cache[ix].hold) {
+					NET_COUNT_IP4(net_count_ip4[NC_IP4_OUT_ERR_PACKETS], 1);
+					syscall(rel_net_buf(arp_cache[ix].hold));
+					}
+				memset(&arp_cache[ix], 0, sizeof(T_ARP_ENTRY));
+				}
+			}
+		}
+
+	syscall(sig_sem(SEM_ARP_CACHE_LOCK));
+	timeout(arp_timer, NULL, ARP_TIMER_TMO);
+	}
+
+/*
  *  arp_lookup -- ARP キャッシュの探索と登録
  *
@@ -128,5 +288,5 @@
  */
 
-static T_ARP_ENTRY *
+T_ARP_ENTRY *
 arp_lookup (T_IN4_ADDR addr, bool_t create)
 {
@@ -170,159 +330,4 @@
 
 /*
- *  in_arpinput -- TCP/IP 用 ARP の入力関数
- */
-
-static void
-in_arpinput (T_IF_ADDR *ifaddr, T_NET_BUF *input)
-{
-	T_NET_BUF	*pending;
-	T_ETHER_HDR	*eth;
-	T_ARP_HDR	*arph;
-	T_ETHER_ARP_HDR	*et_arph;
-	T_ARP_ENTRY	*ent;
-	T_IFNET		*ifp = IF_GET_IFNET();
-	T_IN4_ADDR	saddr, taddr;
-
-	et_arph = GET_ETHER_ARP_HDR(input);
-
-	ntoahl(saddr, et_arph->sproto);		/* 送信元 IP アドレス	*/
-	ntoahl(taddr, et_arph->tproto);		/* 解決対象 IP アドレス	*/
-
-	/*
-	 *  以下の場合はエラー
-	 *    ・送信ホストの物理アドレスが自分
-	 *    ・送信ホストの物理アドレスがブロードキャスト
-	 */
-	if (memcmp(et_arph->shost, ifaddr->lladdr,        ETHER_ADDR_LEN) == 0 ||
-	    memcmp(et_arph->shost, ether_broad_cast_addr, ETHER_ADDR_LEN) == 0)
-		goto err_ret;
-
-	/*
-	 *  送信ホストの IP アドレスが自分の場合は、重複しているので
-	 *  相手にも知らせる。
-	 */
-	if (saddr == ifp->in_ifaddr.addr) {
-
-#ifdef ARP_CFG_CALLBACK_DUPLICATED
-
-		if (arp_callback_duplicated(et_arph->shost)) {
-			syslog(LOG_ERROR, "[ARP] IP address duplicated: %s", mac2str(NULL, et_arph->shost));
-			taddr = saddr;
-			goto reply;
-			}
-		else
-			goto buf_rel;
-
-#else	/* of #ifdef ARP_CFG_CALLBACK_DUPLICATED */
-
-		syslog(LOG_ERROR, "[ARP] IP address duplicated: %s", mac2str(NULL, et_arph->shost));
-		taddr = saddr;
-		goto reply;
-
-#endif	/* of #ifdef ARP_CFG_CALLBACK_DUPLICATED */
-
-		}
-
-	/*
-	 *  以下の場合は何もしない。
-	 *    ・解決対象 IP アドレスが自分ではない、注: 元の FreeBSD の
-	 *      実装では、ARP PROXY 等のため、自分以外の IP アドレスの
-	 *      解決も行っているが、本実装では、自分以外の IP
-	 *      アドレスの解決は行わない。
-	 */
-	if (taddr != ifp->in_ifaddr.addr)
-		goto buf_rel;
-
-	/*
-	 *  送信元 IP アドレスが ARP キャッシュにあるか調べる。
-	 *  キャッシュになければ、新たにエントリを登録する。
-	 */
-	syscall(wai_sem(SEM_ARP_CACHE_LOCK));
-	ent = arp_lookup(saddr, true);
-
-	memcpy(ent->mac_addr, et_arph->shost, ETHER_ADDR_LEN);
-	ent->expire = ARP_CACHE_KEEP;
-
-	/*
-	 *  送信がペンデングされているフレームがあれば送信する。
-	 */
-	if (ent->hold) {
-
-		/* フレームの Ethernet ヘッダを設定する。*/
-		memcpy(GET_ETHER_HDR(ent->hold)->dhost, ent->mac_addr, ETHER_ADDR_LEN);
-
-		pending = ent->hold;
-		ent->hold = NULL;
-		syscall(sig_sem(SEM_ARP_CACHE_LOCK));
-
-		/* ペンディングされているフレームを送信する。*/
-		IF_RAW_OUTPUT(pending, TMO_FEVR);
-
-		}
-	else
-		syscall(sig_sem(SEM_ARP_CACHE_LOCK));
-
-reply:
-
-	arph = GET_ARP_HDR(input);
-
-	/* アドレス解決要求でなければ終了 */
-	if (ntohs(arph->opcode) != ARPOP_REQUEST)
-		goto buf_rel;
-
-	/* Ethernet ARP ヘッダを設定する。*/
-	memcpy(et_arph->thost, et_arph->shost, ETHER_ADDR_LEN);
-	memcpy(et_arph->shost, ifaddr->lladdr, ETHER_ADDR_LEN);
-	memcpy(et_arph->tproto, (uint8_t*)&et_arph->sproto, sizeof(T_IN_ADDR));
-	ahtonl(et_arph->sproto, taddr);
-
-	/* Ethernet ARP ヘッダを設定する。*/
-	arph->opcode = htons(ARPOP_REPLY);
-
-	/* Ethernet ヘッダを設定する。*/
-	eth = GET_ETHER_HDR(input);
-	memcpy(eth->dhost, eth->shost,     ETHER_ADDR_LEN);
-	memcpy(eth->shost, ifaddr->lladdr, ETHER_ADDR_LEN);
-
-	/* ARP 応答を送信する。*/
-	IF_RAW_OUTPUT(input, TMO_FEVR);
-	return;
-
-err_ret:
-	NET_COUNT_ARP(net_count_arp.in_err_packets, 1);
-buf_rel:
-	syscall(rel_net_buf(input));
-	}
-
-/*
- *  arp_timer -- ARP キャッシュの更新
- */
-
-static void
-arp_timer (void *ignore)
-{
-	int_t	ix;
-
-	syscall(wai_sem(SEM_ARP_CACHE_LOCK));
-
-	for (ix = NUM_ARP_ENTRY; ix -- > 0; ) {
-		if (arp_cache[ix].expire) {
-			arp_cache[ix].expire -= ARP_TIMER_TMO;
-			if (arp_cache[ix].expire == 0) {
-				/* 送信がペンデングされているフレームがあれば捨てる。*/
-				if (arp_cache[ix].hold) {
-					NET_COUNT_IP4(net_count_ip4[NC_IP4_OUT_ERR_PACKETS], 1);
-					syscall(rel_net_buf(arp_cache[ix].hold));
-					}
-				memset(&arp_cache[ix], 0, sizeof(T_ARP_ENTRY));
-				}
-			}
-		}
-
-	syscall(sig_sem(SEM_ARP_CACHE_LOCK));
-	timeout(arp_timer, NULL, ARP_TIMER_TMO);
-	}
-
-/*
  *  arp_request -- MAC アドレス解決要求
  */
@@ -359,5 +364,5 @@
 		/* イーサネット ARP ヘッダを設定する。*/
 		et_arph = GET_ETHER_ARP_HDR(arp_req);
-		src     = IF_GET_IFNET()->in_ifaddr.addr;
+		src     = IF_GET_IFNET()->in4_ifaddr.addr;
 		memcpy(et_arph->shost, ifaddr->lladdr, ETHER_ADDR_LEN);
 		memset(et_arph->thost, 0,              ETHER_ADDR_LEN);
@@ -444,5 +449,5 @@
 	 */
 	if (gw == IPV4_ADDR_BROADCAST ||
-	    gw == ((ifp->in_ifaddr.addr & ifp->in_ifaddr.mask) | ~ifp->in_ifaddr.mask)) {
+	    gw == ((ifp->in4_ifaddr.addr & ifp->in4_ifaddr.mask) | ~ifp->in4_ifaddr.mask)) {
 		memcpy(eth->dhost, ether_broad_cast_addr, ETHER_ADDR_LEN);
 		return true;
@@ -504,9 +509,9 @@
 	eaddr->lladdr[1] = UINT_C(0x00);
 	eaddr->lladdr[2] = UINT_C(0x5E);
-	eaddr->lladdr[3] = (maddr & 0x7F0000) >> 16;
-	eaddr->lladdr[4] = (maddr & 0xFF00) >> 8;
-	eaddr->lladdr[5] = maddr & 0xFF;
+	eaddr->lladdr[3] = (uint8_t)((maddr & 0x7F0000) >> 16);
+	eaddr->lladdr[4] = (uint8_t)((maddr & 0xFF00) >> 8);
+	eaddr->lladdr[5] = (uint8_t)(maddr & 0xFF);
 	}
 #endif	/* ETHER_CFG_MULTICAST */
 
-#endif	/* of #if defined(SUPPORT_INET4) && defined(SUPPORT_ETHER) */
+#endif	/* of #if defined(_IP4_CFG) && defined(SUPPORT_ETHER) */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/if_ether.cfg
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/if_ether.cfg	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/if_ether.cfg	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -36,5 +36,5 @@
  */
 
-#ifdef SUPPORT_ETHER
+#if defined(_IP4_CFG) && defined(SUPPORT_ETHER)
 
 /* ARP キャッシュ更新用セマフォ */
@@ -42,3 +42,3 @@
 CRE_SEM(SEM_ARP_CACHE_LOCK, { TA_TPRI, 1, 1 });
 
-#endif	/* of #ifdef SUPPORT_ETHER */
+#endif	/* of #if defined(_IP4_CFG) && defined(SUPPORT_ETHER) */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/if_ether.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/if_ether.h	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/if_ether.h	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -106,4 +106,5 @@
  */
 
+extern T_ARP_ENTRY *arp_lookup (T_IN4_ADDR addr, bool_t create);
 extern ER arp_request (T_IF_ADDR *ifaddr, T_IN4_ADDR dst);
 extern void arp_input (T_IF_ADDR *ifaddr, T_NET_BUF *input);
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in.h	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in.h	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -73,4 +73,5 @@
 #include <tinet_kernel_defs.h>
 
+#include <netinet/in4.h>
 #include <netinet6/in6.h>
 
@@ -79,5 +80,5 @@
  */
 
-#define TINET_PRVER		UINT_C(0x1054)	/* TINET のバージョン番号 */
+#define TINET_PRVER		UINT_C(0x1070)	/* TINET のバージョン番号 */
 
 /*
@@ -92,4 +93,5 @@
 #define IPPROTO_HOPOPTS		UINT_C(0)	/* IPv6 中継点 (Hop-by-Hop) オプション	*/
 #define IPPROTO_ICMP		UINT_C(1)	/* ICMP					*/
+#define IPPROTO_IGMP		UINT_C(2)	/* IGMP					*/
 #define IPPROTO_TCP		UINT_C(6)	/* TCP					*/
 #define IPPROTO_UDP		UINT_C(17)	/* UDP					*/
@@ -107,31 +109,7 @@
 
 /*
- *  IPv4 アドレス
+ *  ポートの長さ
  */
 
-/* 前方参照 */
-
-#ifndef T_IN4_ADDR_DEFINED
-
-typedef uint32_t T_IN4_ADDR;
-
-#define T_IN4_ADDR_DEFINED
-
-#endif	/* of #ifndef T_IN4_ADDR_DEFINED */
-
-/*
- *  ITRON TCP/IPv4 アドレス/ポート番号の定義
- */
-
-typedef struct t_ipv4ep {
-	uint32_t	ipaddr;		/* IPv4 アドレス	*/
-	uint16_t	portno;		/* ポート番号		*/
-	} T_IPV4EP;
-
-/*
- *  アドレス/ポートの長さ
- */
-
-#define IPV4_ADDR_LEN		4
 #define PORT_NUM_LEN		2
 
@@ -152,109 +130,43 @@
 
 /*
- *  IP アドレスの定義
+ *  API IPプロトコルの指定
  */
 
-#define IPV4_ADDRANY		ULONG_C(0x00000000)	/* ITRON TCP/IP 標準	*/
-
-#define IPV4_ADDR_LOOPBACK	ULONG_C(0x7f000001)
-#define IPV4_ADDR_LOOPBACK_MASK	IPV4_CLASS_A_MASK
-#define IPV4_ADDR_BROADCAST	ULONG_C(0xffffffff)
-
-#define IPV4_CLASS_A(i)		(((i) & ULONG_C(0x80000000)) == 0)
-#define IPV4_CLASS_A_NET	ULONG_C(0xff000000)
-#define IPV4_CLASS_A_MASK	ULONG_C(0xff000000)
-#define IPV4_CLASS_A_HOST	ULONG_C(0x00ffffff)
-
-#define IPV4_CLASS_B(i)		(((i) & ULONG_C(0xc0000000)) == ULONG_C(0x80000000))
-#define IPV4_CLASS_B_NET	ULONG_C(0xffff0000)
-#define IPV4_CLASS_B_MASK	ULONG_C(0xffff0000)
-#define IPV4_CLASS_B_HOST	ULONG_C(0x0000ffff)
-
-#define IPV4_CLASS_C(i)		(((i) & ULONG_C(0xe0000000)) == ULONG_C(0xc0000000))
-#define IPV4_CLASS_C_NET	ULONG_C(0xffffff00)
-#define IPV4_CLASS_C_MASK	ULONG_C(0xffffff00)
-#define IPV4_CLASS_C_HOST	ULONG_C(0x000000ff)
-
-#define IPV4_CLASS_D(i)		(((i) & ULONG_C(0xf0000000)) == ULONG_C(0xe0000000))
-
-#define IN4_IS_ADDR_MULTICAST(i)	IPV4_CLASS_D(i)
-
-#define MAKE_IPV4_LOCAL_BROADCAST(i)	(IPV4_CLASS_A(i)?((i)|IPV4_CLASS_A_HOST):\
-					 IPV4_CLASS_B(i)?((i)|IPV4_CLASS_B_HOST):\
-					 IPV4_CLASS_C(i)?((i)|IPV4_CLASS_C_HOST):\
-					 IPV4_ADDR_BROADCAST)
-
-#define MAKE_IPV4_LOCAL_MASK(i)		(IPV4_CLASS_A(i)?IPV4_CLASS_A_MASK:\
-					 IPV4_CLASS_B(i)?IPV4_CLASS_B_MASK:\
-					 IPV4_CLASS_C(i)?IPV4_CLASS_C_MASK:\
-					 IPV4_ADDRANY)
-
-#define MAKE_IPV4_ADDR(a,b,c,d)		((T_IN4_ADDR)(((uint32_t)(a)<<24)|((uint32_t)(b)<<16)|((uint32_t)(c)<<8)|(d)))
+#define API_PROTO_IPVn			'n'
+#define API_PROTO_IPV6			'6'
+#define API_PROTO_IPV4			'4'
 
 /*
- *  動的生成用 TCP 通信端点
+ *  動的生成用 TCP/IPv6 通信端点
  */
 
-typedef struct t_tcp_ccep {
-	/* 標準 */
-	ATR		cepatr;		/* 通信端点属性			*/
-	void		*sbuf;		/* 送信用ウィンドバッファ	*/
-	int_t		sbufsz;		/* 送信用ウィンドバッファサイズ	*/
-	void		*rbuf;		/* 受信用ウィンドバッファ	*/
-	int_t		rbufsz;		/* 受信用ウィンドバッファサイズ	*/
-	FP		callback;	/* コールバック			*/
-	/* 実装依存 */
-	} T_TCP_CCEP;
+#define T_TCP6_CCEP			T_TCP_CCEP
 
 /*
- *  動的生成用 TCP 受付口
+ *  バイトオーダ関数の定義
+ *
+ *    tinet/net/net.h でもバイトオーダの定義を行っているが、
+ *    tinet/net/net.h をインクルードしない
+ *    アプリケーションプログラム用に
+ *    ターゲット依存しないバイトオーダ関数を定義する。
  */
 
-#if defined(SUPPORT_INET4)
+#if defined(_NET_CFG_BYTE_ORDER)
 
-typedef struct t_tcp_crep {
-	/* 標準 */
-	ATR		repatr;		/* 受付口属性		*/
-	T_IPV4EP	myaddr;		/* 自分のアドレス	*/
-	/* 実装依存 */
-	} T_TCP_CREP;
+/*  tinet/net/net.h をインクルードしている。*/
 
-#endif	/* of #if defined(SUPPORT_INET4) */
+#else	/* of #if defined(_NET_CFG_BYTE_ORDER) */
 
-/*
- *  動的生成用 UDP 通信端点
- */
+extern uint16_t ntohs (uint16_t net);
+extern uint16_t htons (uint16_t host);
+extern uint32_t ntohl (uint32_t net);
+extern uint32_t htonl (uint32_t host);
 
-#if defined(SUPPORT_INET4)
+#define NTOHS(n)	(n=ntohs(n))
+#define HTONS(h)	(h=htons(h))
+#define NTOHL(n)	(n=ntohl(n))
+#define HTONL(h)	(h=htonl(h))
 
-typedef struct t_udp_ccep {
-	/* 標準 */
-	ATR		cepatr;		/* UDP 通信端点属性		*/
-	T_IPV4EP	myaddr;		/* 自分のアドレス		*/
-	FP		callback;	/* コールバック関数		*/
-	/* 実装依存 */
-	} T_UDP_CCEP;
-
-#endif	/* of #if defined(SUPPORT_INET4) */
-
-/*
- *  IPv4 と IPv6 をコンパイル時に選択するためのマクロ
- */
-
-#if defined(SUPPORT_INET4)
-
-#define T_IN_ADDR			T_IN4_ADDR
-#define T_IPEP				T_IPV4EP
-#define IP_ADDRANY			IPV4_ADDRANY
-
-#define IN_ARE_ADDR_EQUAL(n,h)		(*(n)==*(h))
-#define IN_ARE_NET_ADDR_EQUAL(n,h)	(ntohl(*(n))==*(h))
-#define IN_COPY_TO_NET(d,s)		(*(d)=htonl(*(s)))
-#define IN_COPY_TO_HOST(d,s)		(*(d)=ntohl(*(s)))
-#define IN_IS_ADDR_MULTICAST(a)		IN4_IS_ADDR_MULTICAST(*(a))
-#define IN_IS_NET_ADDR_MULTICAST(a)	IN4_IS_ADDR_MULTICAST(ntohl(*(a)))
-#define IN_IS_ADDR_ANY(a)		(*(a)==IPV4_ADDRANY)
-
-#endif	/* of #if defined(SUPPORT_INET4) */
+#endif	/* of #if defined(_NET_CFG_BYTE_ORDER) */
 
 /*
@@ -264,13 +176,3 @@
 extern const char *in_strtfn (FN fncd);
 
-#if defined(SUPPORT_INET4)
-
-extern ER in4_add_ifaddr (T_IN4_ADDR addr, T_IN4_ADDR mask);
-extern ER in4_add_route (int_t index, T_IN4_ADDR target,
-                                      T_IN4_ADDR mask, T_IN4_ADDR gateway);
-extern char *ip2str (char *buf, const T_IN4_ADDR *p_ipaddr);
-extern const T_IN4_ADDR *in4_get_ifaddr (int_t index);
-
-#endif	/* of #if defined(SUPPORT_INET4) */
-
 #endif	/* of #ifndef _IN_H_ */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in4.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in4.h	(revision 331)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/in4.h	(revision 331)
@@ -0,0 +1,220 @@
+/*
+ *  TINET (TCP/IP Protocol Stack)
+ * 
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
+ *                   Tomakomai National College of Technology, JAPAN
+ *
+ *  ä¸è¨èä½æ¨©è
+ã¯ï¼ä»¥ä¸ã® (1)ï½(4) ã®æ¡ä»¶ãï¼Free Software Foundation 
+ *  ã«ãã£ã¦å
+¬è¡¨ããã¦ãã GNU General Public License ã® Version 2 ã«è¨
+ *  è¿°ããã¦ããæ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§ã¢ï¼æ¬ã½ããã¦ã§ã¢
+ *  ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹å¤ã»åé
+å¸ï¼ä»¥ä¸ï¼
+ *  å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
+ *  (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
+ *      æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
+ *      ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
+ *  (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
+ *      è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
+ *      ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *  (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããªãå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼æ¬¡ã®æ¡ä»¶ãæºãããã¨ï¼
+ *    (a) åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
+ *        ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *  (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
+ *      å®³ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ããå
+è²¬ãããã¨ï¼
+ *
+ *  æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
+ã
+ *  ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ãã®é©ç¨å¯è½æ§ã
+ *  å«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´
+ *  æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ãã®è²¬ä»»ãè² ããªãï¼
+ * 
+ *  @(#) $Id$
+ */
+
+/*
+ * Copyright (c) 1982, 1986, 1990, 1993
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *	This product includes software developed by the University of
+ *	California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *	@(#)in.h	8.3 (Berkeley) 1/3/94
+ * $FreeBSD: src/sys/netinet/in.h,v 1.38.2.3 1999/08/29 16:29:34 peter Exp $
+ */
+ 
+#ifndef _IN4_H_
+#define _IN4_H_
+
+/*
+ *  IPv4 ã¢ãã¬ã¹
+ */
+
+/* åæ¹åç
+§ */
+
+#ifndef T_IN4_ADDR_DEFINED
+
+typedef uint32_t T_IN4_ADDR;
+
+#define T_IN4_ADDR_DEFINED
+
+#endif	/* of #ifndef T_IN4_ADDR_DEFINED */
+
+/*
+ *  ITRON TCP/IPv4 ã¢ãã¬ã¹/ãã¼ãçªå·ã®å®ç¾©
+ */
+
+typedef struct t_ipv4ep {
+	uint32_t	ipaddr;		/* IPv4 ã¢ãã¬ã¹	*/
+	uint16_t	portno;		/* ãã¼ãçªå·		*/
+	} T_IPV4EP;
+
+#define T_IPV4EP_DEFINED
+
+/*
+ *  ã¢ãã¬ã¹ã®é·ã
+ */
+
+#define IPV4_ADDR_LEN		4
+
+/*
+ *  IPv4 ã¢ãã¬ã¹ã®å®ç¾©
+ */
+
+#define IPV4_ADDRANY		ULONG_C(0x00000000)	/* ITRON TCP/IP æ¨æº	*/
+#define IPV4_ADDRBROADCAST	ULONG_C(0xffffffff)
+
+#define IPV4_ADDR_LOOPBACK	ULONG_C(0x7f000001)
+#define IPV4_ADDR_LOOPBACK_MASK	IPV4_CLASS_A_MASK
+#define IPV4_ADDR_BROADCAST	ULONG_C(0xffffffff)
+
+#define IPV4_CLASS_A(i)		(((i) & ULONG_C(0x80000000)) == 0)
+#define IPV4_CLASS_A_NET	ULONG_C(0xff000000)
+#define IPV4_CLASS_A_MASK	ULONG_C(0xff000000)
+#define IPV4_CLASS_A_HOST	ULONG_C(0x00ffffff)
+
+#define IPV4_CLASS_B(i)		(((i) & ULONG_C(0xc0000000)) == ULONG_C(0x80000000))
+#define IPV4_CLASS_B_NET	ULONG_C(0xffff0000)
+#define IPV4_CLASS_B_MASK	ULONG_C(0xffff0000)
+#define IPV4_CLASS_B_HOST	ULONG_C(0x0000ffff)
+
+#define IPV4_CLASS_C(i)		(((i) & ULONG_C(0xe0000000)) == ULONG_C(0xc0000000))
+#define IPV4_CLASS_C_NET	ULONG_C(0xffffff00)
+#define IPV4_CLASS_C_MASK	ULONG_C(0xffffff00)
+#define IPV4_CLASS_C_HOST	ULONG_C(0x000000ff)
+
+#define IPV4_CLASS_D(i)		(((i) & ULONG_C(0xf0000000)) == ULONG_C(0xe0000000))
+
+#define IN4_IS_ADDR_MULTICAST(i)	IPV4_CLASS_D(i)
+
+#define MAKE_IPV4_LOCAL_BROADCAST(i)	(IPV4_CLASS_A(i)?((i)|IPV4_CLASS_A_HOST):\
+					 IPV4_CLASS_B(i)?((i)|IPV4_CLASS_B_HOST):\
+					 IPV4_CLASS_C(i)?((i)|IPV4_CLASS_C_HOST):\
+					 IPV4_ADDR_BROADCAST)
+
+#define MAKE_IPV4_LOCAL_MASK(i)		(IPV4_CLASS_A(i)?IPV4_CLASS_A_MASK:\
+					 IPV4_CLASS_B(i)?IPV4_CLASS_B_MASK:\
+					 IPV4_CLASS_C(i)?IPV4_CLASS_C_MASK:\
+					 IPV4_ADDRANY)
+
+#define MAKE_IPV4_ADDR(a,b,c,d)		((T_IN4_ADDR)(((uint32_t)(a)<<24)|((uint32_t)(b)<<16)|((uint32_t)(c)<<8)|(d)))
+
+/*
+ *  é¢æ°ã·ãã¥ã¬ã¼ã·ã§ã³ãã¯ã­
+ */
+
+#define IN4_ARE_ADDR_EQUAL(dst,src)	(*(dst)==*(src))
+#define IN4_IS_ADDR_ANY(addr)		(*(addr)==IPV4_ADDRANY)
+#define IN4_IS_ADDR_BROADCAST(addr)	(*(addr)==IPV4_ADDRBROADCAST)
+#define ip2str(buf,p_ipaddr)		(ipv42str(buf,p_ipaddr))
+
+/*
+ *  åççæç¨ TCP éä¿¡ç«¯ç¹
+ */
+
+typedef struct t_tcp_ccep {
+	/* æ¨æº */
+	ATR		cepatr;		/* éä¿¡ç«¯ç¹å±æ§			*/
+	void		*sbuf;		/* éä¿¡ç¨ã¦ã£ã³ããããã¡	*/
+	int_t		sbufsz;		/* éä¿¡ç¨ã¦ã£ã³ããããã¡ãµã¤ãº	*/
+	void		*rbuf;		/* åä¿¡ç¨ã¦ã£ã³ããããã¡	*/
+	int_t		rbufsz;		/* åä¿¡ç¨ã¦ã£ã³ããããã¡ãµã¤ãº	*/
+	FP		callback;	/* ã³ã¼ã«ããã¯			*/
+	/* å®è£
+ä¾å­ */
+	} T_TCP_CCEP;
+
+/*
+ *  åççæç¨ TCP åä»å£
+ */
+
+typedef struct t_tcp_crep {
+	/* æ¨æº */
+	ATR		repatr;		/* åä»å£å±æ§		*/
+	T_IPV4EP	myaddr;		/* èªåã®ã¢ãã¬ã¹	*/
+	/* å®è£
+ä¾å­ */
+	} T_TCP_CREP;
+
+/*
+ *  åççæç¨ UDP éä¿¡ç«¯ç¹
+ */
+
+typedef struct t_udp_ccep {
+	/* æ¨æº */
+	ATR		cepatr;		/* UDP éä¿¡ç«¯ç¹å±æ§		*/
+	T_IPV4EP	myaddr;		/* èªåã®ã¢ãã¬ã¹		*/
+	FP		callback;	/* ã³ã¼ã«ããã¯é¢æ°		*/
+	/* å®è£
+ä¾å­ */
+	} T_UDP_CCEP;
+
+/*
+ *  TINET ç¬èª API
+ */
+
+extern char *ipv42str (char *buf, const T_IN4_ADDR *p_ipaddr);
+extern uint_t in4_get_maxnum_ifaddr (void);
+extern const T_IN4_ADDR *in4_get_ifaddr (int_t index);
+extern ER in4_add_ifaddr (T_IN4_ADDR addr, T_IN4_ADDR mask);
+extern ER in4_add_route (int_t index, T_IN4_ADDR target,
+                                      T_IN4_ADDR mask, T_IN4_ADDR gateway);
+
+#endif	/* of #ifndef _IN4_H_ */
